#dr3mro@gmail.com
#nautilus python advanced context menu
#v 0.1

from gi.repository import Nautilus, GObject
import os
import subprocess
import urllib
import shutil


class AdvancedMenu(GObject.GObject, Nautilus.MenuProvider):
    def __init__(self):
        pass


    def url2path(self,url):
        fileuri= url.get_activation_uri()
        arg_uri=fileuri[7:]
        path=urllib.url2pathname(arg_uri)
        return path


    def pastebin_run(self,menu,file):
        path=self.url2path(file)
        subprocess.Popen(['/usr/bin/pastebin',path])
        return


    def emblemize3_run(self,menu,file):
        path=self.url2path(file)
        subprocess.Popen(['/usr/bin/emblemize3',path])
        return

    def calculate_run(self,menu,file):
        path=self.url2path(file)
        subprocess.Popen(['/usr/bin/calsize',path])
        return

    def filetype_run(self,menu,file):
        path=self.url2path(file)
        subprocess.Popen(['/usr/bin/filetype',path])
        return

    def utf2cp1256_run(self,menu,file):
        path=self.url2path(file)
        backup=path+'.old'
        shutil.copyfile(path,backup)
        exe=['iconv','-f','utf-8','-t','windows-1256',path,'-o',path]
        subprocess.Popen(exe)
        return

    def cp12562utf_run(self,menu,file):
        path=self.url2path(file)
        backup=path+'.old'
        shutil.copyfile(path,backup)
        exe=['iconv','-f','windows-1256','-t','utf-8',path,'-o',path]
        subprocess.Popen(exe)
        return


    def mount_run(self,menu,file):
        path=self.url2path(file)
        pathdir=os.path.dirname(path)
        os.chdir(pathdir)
        subprocess.Popen(['gksu','bash','mountiso',path])
        return


    def unmount_run(self,menu,file):
        path=self.url2path(file)
        pathdir=os.path.dirname(path)
        os.chdir(pathdir)
        subprocess.Popen(['gksu','bash','unmountiso',path])
        return

    def paste_mimes(self,file):
        mime= file.get_mime_type()
        allowedmimes=['application/x-shellscript','text/x-python','application/x-subrip']
        if mime in allowedmimes:
            supported=True
        elif mime[:4] == 'text':
            supported=True
        else:
            supported=False
        return supported

    def mount_mimes(self,file):
        mime= file.get_mime_type()
        allowedmimes=['application/x-cd-image']
        if mime in allowedmimes:
            supported=True
        else:
            supported=False
        return supported


    def get_file_items(self, window, files):
        filecount=len(files)
        if filecount > 0 :
            file=files[0]
            pastebin_supported=self.paste_mimes(file)
            mountable=self.mount_mimes(file)
        #topmenu
        AdvancedTopMenu = Nautilus.MenuItem(name='TopMenuItem::Advanced', 
                                         label='Advanced', 
                                         tip='Advanced Menu',
                                    )

        AdvancedSubMenu = Nautilus.Menu()
        AdvancedTopMenu.set_submenu(AdvancedSubMenu)

        #pastebin
        if filecount ==1   and pastebin_supported and os.path.exists('/usr/bin/pastebin'):
            PastebinMenuItem = Nautilus.MenuItem(name='AdvancedSubMenu::Pastebinit', 
                                             label='Pastebin uploader', 
                                             tip='upload to pastebin',
                                        )
            PastebinMenuItem.connect('activate',self.pastebin_run,file)
            AdvancedSubMenu.append_item(PastebinMenuItem)

        #emblemize3
        if filecount ==1   and os.path.exists('/usr/bin/emblemize3'):
            Emblemize3MenuItem = Nautilus.MenuItem(name='AdvancedSubMenu::Emblemize3', 
                                             label='Set emblem', 
                                             tip='emblemize 3.x',
                                        )
            Emblemize3MenuItem.connect('activate',self.emblemize3_run,file)
            AdvancedSubMenu.append_item(Emblemize3MenuItem)

        #calculate size
        if filecount ==1   and os.path.exists('/usr/bin/calsize'):
            CalculateMenuItem = Nautilus.MenuItem(name='AdvancedSubMenu::Calculate', 
                                             label='Calculate size', 
                                             tip='Calculate size',
                                        )
            CalculateMenuItem.connect('activate',self.calculate_run,file)
            AdvancedSubMenu.append_item(CalculateMenuItem)

        #Check file type
        if filecount ==1   and os.path.exists('/usr/bin/filetype'):
            FileTypeMenuItem = Nautilus.MenuItem(name='AdvancedSubMenu::FileType', 
                                             label='Check file type', 
                                             tip='Check file type',
                                        )
            FileTypeMenuItem.connect('activate',self.filetype_run,file)
            AdvancedSubMenu.append_item(FileTypeMenuItem)

        #convert char encoding utf2cp1256
        if filecount ==1   and os.path.exists('/usr/bin/iconv') and pastebin_supported:
            utf2cp1256MenuItem = Nautilus.MenuItem(name='AdvancedSubMenu::utf2cp1256', 
                                             label='convert utf8 to cp-1256', 
                                             tip='convert utf8 to cp-1256',
                                        )
            utf2cp1256MenuItem.connect('activate',self.utf2cp1256_run,file)
            AdvancedSubMenu.append_item(utf2cp1256MenuItem)


        #convert char encoding utf2cp1256
        if filecount ==1   and os.path.exists('/usr/bin/iconv') and pastebin_supported:
            cp12562utfMenuItem = Nautilus.MenuItem(name='AdvancedSubMenu::cp12562utf', 
                                             label='convert cp-1256 to utf8', 
                                             tip='convert cp-1256 to utf8',
                                        )
            cp12562utfMenuItem.connect('activate',self.cp12562utf_run,file)
            AdvancedSubMenu.append_item(cp12562utfMenuItem)


        #mount ISO
        if filecount ==1   and mountable and os.path.exists('/usr/bin/mountiso'):
            MountISOMenuItem = Nautilus.MenuItem(name='AdvancedSubMenu::MountISO', 
                                             label='Mount ISO', 
                                             tip='Mount ISO file',
                                        )
            MountISOMenuItem.connect('activate',self.mount_run,file)
            AdvancedSubMenu.append_item(MountISOMenuItem)

        #unmount ISO
        if filecount ==1   and mountable and os.path.exists('/usr/bin/unmountiso'):
            UNMountISOMenuItem = Nautilus.MenuItem(name='AdvancedSubMenu::UNMountISO', 
                                             label='UnMount ISO', 
                                             tip='UnMount ISO file',
                                        )
            UNMountISOMenuItem.connect('activate',self.unmount_run,file)
            AdvancedSubMenu.append_item(UNMountISOMenuItem)

        return AdvancedTopMenu,
