#checksum
#dr3mro@gmail.com
#0.2

from gi.repository import Nautilus, GObject
import os
import subprocess
import urllib

class Checksum(GObject.GObject, Nautilus.MenuProvider):
    def __init__(self):
        pass



    def url2path(self,url):
        fileuri= url.get_activation_uri()
        arg_uri=fileuri[7:]
        path=urllib.url2pathname(arg_uri)
        return path

    def genmd5(self,menu,files):
        exe=['genmd5']
        for file in files:
            path=self.url2path(file)
            exe.append(path)
        subprocess.Popen(exe)
        return

    def viewmd5(self,menu,files):
        exe=['viewmd5']
        for file in files:
            path=self.url2path(file)
            exe.append(path)
        subprocess.Popen(exe)
        return

    def gendirmd5(self,menu,files):
        for file in files:
            path=self.url2path(file)
            subprocess.Popen(['gendirmd5',path])
        return


    def isdir(self,files):
        isdir=False
        for file in files:
            mime= file.get_mime_type()
            if mime =='inode/directory':
                isdir=True
                return isdir
            else:
                isdir=False
        return isdir

    def isfile(self,files):
        isfile=False
        for file in files:
            mime= file.get_mime_type()
            if mime !='inode/directory':
                isfile=True
                return isfile
            else:
                isfile=False
        return isfile

    def ishash(self,file):
        path=self.url2path(file)
        extension = os.path.splitext(path)[1]
        ext=extension.lower()
        if ext == '.md5':
            return True
        name=os.path.splitext(path)[0]
        if 'md5' in name:
            return True
        return False



    def verifymd5(self,menu,file):
        path=self.url2path(file)
        subprocess.Popen(['verifymd5',path])
        return

    def get_file_items(self, window, files):
        filecount=len(files)
        if filecount > 0 :
            file=files[0]
            parent_path=self.url2path(file)
            
            ishash=self.ishash(file)
            isdir=self.isdir(files)
            isfile=self.isfile(files)
        else:
            return 


        ChecksumTopMenu = Nautilus.MenuItem(name='TopMenuItem::Checksum', 
                                         label='Checksum', 
                                         tip='Checksum',
                                    )
        ChecksumSubMenu = Nautilus.Menu()
        ChecksumTopMenu.set_submenu(ChecksumSubMenu)

        if os.path.exists('/usr/bin/genmd5') and not isdir and isfile:
            GenMD5Item = Nautilus.MenuItem(name='ChecksumSubMenu::GenMD5', 
                                             label='Generate and save MD5', 
                                             tip='Generate and save MD5',
                                        )
            GenMD5Item.connect('activate',self.genmd5,files)
            ChecksumSubMenu.append_item(GenMD5Item)

        if os.path.exists('/usr/bin/viewmd5') and not isdir and isfile:
            ViewMD5Item = Nautilus.MenuItem(name='ChecksumSubMenu::ViewMD5', 
                                             label='Generate and view MD5', 
                                             tip='Generate and view MD5',
                                        )
            ViewMD5Item.connect('activate',self.viewmd5,files)
            ChecksumSubMenu.append_item(ViewMD5Item)

        if os.path.exists('/usr/bin/gendirmd5') and isdir and not isfile:
            GenDirMD5Item = Nautilus.MenuItem(name='ChecksumSubMenu::GenDirMD5', 
                                             label='Generate MD5 for selected folder(s)', 
                                             tip='Generate MD5 for selected folder(s)',
                                        )
            GenDirMD5Item.connect('activate',self.gendirmd5,files)
            ChecksumSubMenu.append_item(GenDirMD5Item)

        if filecount == 1 and os.path.exists('/usr/bin/verifymd5') and ishash:
            VerifyMD5Item = Nautilus.MenuItem(name='ChecksumSubMenu::VerifyMD5', 
                                             label='Verify MD5', 
                                             tip='Verify MD5',
                                        )
            VerifyMD5Item.connect('activate',self.verifymd5,file)
            ChecksumSubMenu.append_item(VerifyMD5Item)


        return [ChecksumTopMenu]
