#dr3mro@gmail.com
#nautilus python multimedia context menu
#v 0.1

from gi.repository import Nautilus, GObject
import os
import subprocess
import urllib


class MultiMediaMenu(GObject.GObject, Nautilus.MenuProvider):
    def __init__(self):
        pass


    def url2path(self,url):
        fileuri= url.get_activation_uri()
        arg_uri=fileuri[7:]
        path=urllib.url2pathname(arg_uri)
        return path


    def imgizor_run(self,menu,file):
        imgizor_path=self.url2path(file)
        subprocess.Popen(['/usr/bin/imgizor',imgizor_path])
        return


    def imageshack_run(self,menu,files):
        files_path=['imageshack-uploader']
        for file in files:
            imageshack_path=self.url2path(file)
            files_path.append(imageshack_path)
        subprocess.Popen(files_path)
        return


    def gifconvert_run(self,menu,files):
        files_path=['2GIF']
        for file in files:
            gif_path=self.url2path(file)
            files_path.append(gif_path)
        subprocess.Popen(files_path)
        return


    def jpgconvert_run(self,menu,files):
        files_path=['2JPG']
        for file in files:
            jpg_path=self.url2path(file)
            files_path.append(jpg_path)
        subprocess.Popen(files_path)
        return


    def pngconvert_run(self,menu,files):
        files_path=['2PNG']
        for file in files:
            png_path=self.url2path(file)
            files_path.append(png_path)
        subprocess.Popen(files_path)
        return



    def avconvert_run(self,menu,file):
        avconvert_path=self.url2path(file)
        subprocess.Popen(['/usr/bin/avconvert',avconvert_path])
        return

    def optipng_run(self,menu,file):
        optipng_path=self.url2path(file)
        subprocess.Popen(['/usr/bin/optipng',optipng_path])
        return

    def audioconvert_run(self,menu,file):
        audioconvert_path=self.url2path(file)
        subprocess.Popen(['/usr/bin/ConvertAudioFile',audioconvert_path])
        return




    def get_file_items(self, window, files):
        filecount=len(files)
        mimetype=""
        if filecount > 0 :
            file=files[0]
            mimetype=file.get_mime_type()


        ###############################################################################
        #Multimedia Top Menu
        ###############################################################################
        MultiMediaTopMenu = Nautilus.MenuItem(name='TopMenuItem::MultiMedia', 
                                         label='Multimedia', 
                                         tip='Multimedia Menu',
                                    )

        MultiMediaSubMenu = Nautilus.Menu()
        MultiMediaTopMenu.set_submenu(MultiMediaSubMenu)

        ###############################################################################
        #imgizor menu
        ###############################################################################
        if filecount ==1  and mimetype[:5] == 'image' and os.path.exists('/usr/bin/imgizor'):
            ImgizorMenuItem = Nautilus.MenuItem(name='MultiMediaSubMenu::Imgizor', 
                                             label='Imgizor', 
                                             tip='Image Resize & Rotate',
                                        )
            ImgizorMenuItem.connect('activate',self.imgizor_run,file)
            MultiMediaSubMenu.append_item(ImgizorMenuItem)

        ###############################################################################
        #Imageshack.us
        ###############################################################################
        if mimetype[:5] == 'image' and os.path.exists('/usr/bin/imageshack-uploader'):
            ImageshackMenuItem = Nautilus.MenuItem(name='MultiMediaSubMenu::Imageshack', 
                                             label='Imageshack.us uploader', 
                                             tip='upload to imageshack.us',
                                        )
            ImageshackMenuItem.connect('activate',self.imageshack_run,files)
            MultiMediaSubMenu.append_item(ImageshackMenuItem)

        ###############################################################################
        #AVConvert
        ###############################################################################
        AV_mimes=['image','video','audio']
        Xmimes=['application/vnd.rn-realmedia']
        if filecount ==1   or  mimetype[:5] in AV_mimes or mimetype in Xmimes and os.path.exists('/usr/bin/avconvert'):
            AVConvertMenuItem = Nautilus.MenuItem(name='MultiMediaSubMenu::AVConvert', 
                                             label='AVConvert', 
                                             tip='Convert with AVConvert',
                                        )
            AVConvertMenuItem.connect('activate',self.avconvert_run,file)
            MultiMediaSubMenu.append_item(AVConvertMenuItem)

        ###############################################################################
        #AudioConvert
        ###############################################################################
        if filecount ==1   and mimetype[:5] == 'audio' and os.path.exists('/usr/bin/ConvertAudioFile'):
            AudioConvertMenuItem = Nautilus.MenuItem(name='MultiMediaSubMenu::AudioConvert', 
                                             label='AudioConvert', 
                                             tip='Convert Audio',
                                        )
            AudioConvertMenuItem.connect('activate',self.audioconvert_run,file)
            MultiMediaSubMenu.append_item(AudioConvertMenuItem)

        ###############################################################################
        #GIFConvert
        ###############################################################################
        if mimetype[:5] == 'image' and mimetype != 'image/gif' and os.path.exists('/usr/bin/2GIF'):
            GIFConvertMenuItem = Nautilus.MenuItem(name='MultiMediaSubMenu::GIFConvert', 
                                             label='Convert to GIF', 
                                             tip='Convert image into GIF',
                                        )
            GIFConvertMenuItem.connect('activate',self.gifconvert_run,files)
            MultiMediaSubMenu.append_item(GIFConvertMenuItem)

        ###############################################################################
        #JPGConvert
        ###############################################################################
        jpg_forbed=['image/jpg' ,'image/jpeg']
        if mimetype[:5] == 'image' and mimetype not in jpg_forbed and os.path.exists('/usr/bin/2JPG'):

            JPGConvertMenuItem = Nautilus.MenuItem(name='MultiMediaSubMenu::JPGConvert', 
                                             label='Convert to JPG', 
                                             tip='Convert image into JPG',
                                        )
            JPGConvertMenuItem.connect('activate',self.jpgconvert_run,files)
            MultiMediaSubMenu.append_item(JPGConvertMenuItem)

        ###############################################################################
        #PNGConvert
        ###############################################################################
        if mimetype[:5] == 'image' and mimetype != 'image/png' and os.path.exists('/usr/bin/2PNG'):
            PNGConvertMenuItem = Nautilus.MenuItem(name='MultiMediaSubMenu::PNGConvert', 
                                             label='Convert to PNG', 
                                             tip='Convert image into PNG',
                                        )
            PNGConvertMenuItem.connect('activate',self.pngconvert_run,files)
            MultiMediaSubMenu.append_item(PNGConvertMenuItem)

        ###############################################################################
        #Optimize PNG
        ###############################################################################
        if filecount ==1   and mimetype == 'image/png' and os.path.exists('/usr/bin/optipng'):
            OptimizePNGMenuItem = Nautilus.MenuItem(name='MultiMediaSubMenu::OptimizePNG', 
                                             label='Optimize PNG', 
                                             tip='Optimize PNG',
                                    )
            OptimizePNGMenuItem.connect('activate',self.optipng_run,file)
            MultiMediaSubMenu.append_item(OptimizePNGMenuItem)

        ###############################################################################
        return MultiMediaTopMenu,

