#nautilus open terminal here 
#dr3mro@gmail.com
#version 0.2

from gi.repository import Nautilus
from gi.repository import GObject
import subprocess
import os
import urllib

class TerminalMenu(GObject.GObject, Nautilus.MenuProvider):

    def __init__(self):
        pass

    def url2path(self,url):
        path=urllib.url2pathname(url[7:])
        return path


    def terminal(self, menu,path):
        curpath="%s"%path
        bash_string=["gnome-terminal","--geometry",'100x25',"--working-directory",curpath]
        subprocess.Popen(bash_string)

    def get_file_items(self, window, files):
        if len(files) != 1:
            return

        file = files[0]

        if file.is_directory():
            item = Nautilus.MenuItem(
                name="MenuItem:Terminal",
                label="Open Terminal Here",
                tip="Open Terminal Here"
            )
            path_uri = file.get_uri()
            path=self.url2path(path_uri)
            item.connect('activate', self.terminal,path)
            return [item]
        else:
            return

    def get_background_items(self, window,location):
        path_uri = location.get_uri()
        if path_uri == 'x-nautilus-desktop:///':
            path_uri= "file://"+ os.path.expanduser("~")+"/Desktop"

        if path_uri[:7] != 'file://':
            return

        path=self.url2path(path_uri)
        terminal = Nautilus.MenuItem(
            name="MenuItem::Terminal",
            label="Open Terminal Here",
            tip="Open Terminal Here"
        )

        terminal.connect('activate', self.terminal,path)

        return [terminal]
