#nautilus search
#dr3mro@gmail.com
#version 0.2

from gi.repository import Nautilus, GObject
import subprocess,os, urllib, shlex

class SearchMenu(GObject.GObject, Nautilus.MenuProvider):

    def __init__(self):
        pass

    def search(self, menu,path):
        p = urllib.unquote(path[7:])   # Convert %20 to space
        cm = "gnome-search-tool --path=\"%s\" --contains=" %p
        args = shlex.split(cm)  # To correctly handle the quote " in command arguments
        subprocess.Popen(args)

    def get_file_items(self, window, files):
        if len(files) != 1:
            return

        file = files[0]

        if file.is_directory():
            item = Nautilus.MenuItem(
                name="MenuItem:Search",
                label="Search here...",
                tip="Search here !",
                icon="edit-find"
            )
            path = file.get_uri()
            item.connect('activate', self.search,path)
            return [item]
        else:
            return

    def get_background_items(self, window,location):
        path = location.get_uri()

        if path == 'x-nautilus-desktop:///':
            path= "file://"+ os.path.expanduser("~")+"/Desktop"

        if path[:7] != 'file://':
            return

        search = Nautilus.MenuItem(
            name="MenuItem::Search",
            label="Search here...",
            tip="Search here !",
            icon="edit-find"
        )

        search.connect('activate', self.search,path)

        return [search]
